#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

string lower(string s) {
    string ret;
    for (auto c : s) {
        ret += tolower(c);
    }
    return ret;
}

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);
    
    int n = inf.readInt();
    int m = inf.readInt();
    
    string jans = lower(ans.readLine());
    string pans = lower(ouf.readLine());

    if (pans != "no" && pans != "yes") {
        quitf(_wa, "yes/no expected, %s found", pans.c_str());
    }

    if (pans == "yes") {
        vector<pii> v;
        set<pii> all;
        for (int i = 0; i < n * m; ++i) {
            int x = ouf.readInt(1, n);
            int y = ouf.readInt(1, m);
            v.puba({x, y});
            if (all.count({x, y})) {
                quitf(_wa, "square (%d, %d) occurs more than once", x, y);
            }
            all.insert({x, y});
        }
        for (int i = 0; i < n * m - 2; ++i) {
            int dx1 = v[i + 1].ff - v[i].ff;
            int dy1 = v[i + 1].ss - v[i].ss;
            int dx2 = v[i + 2].ff - v[i + 1].ff;
            int dy2 = v[i + 2].ss - v[i + 1].ss;
            if (dx1 * dy2 - dy1 * dx2 <= 0) {
                quitf(_wa, "incorrect rotate #%d", i + 1);
            }
        }
    }

    if (pans == "no" && jans == "yes") {
        quitf(_wa, "participant didn't find solution");
    }
    if (pans == "yes" && jans == "no") {
        quitf(_fail, "jury didn't find solution");
    }

    quitf(_ok, "answer is correct");

    return 0;
}