#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    int n, m;
    scanf("%d%d", &n, &m);
    
    if (n * m <= 2) {
        cout << "Yes\n";
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << i + 1 << " " << j + 1 << "\n";
            }
        }
        return 0;
    }

    if (n == 1 || m == 1) {
        cout << "No\n";
        return 0;
    }

    cout << "Yes\n";

    if (n % 2 == 0) {
        bool flag = false;
        for (int i = 0; i * 2 < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (!flag) {
                    cout << i + 1 << " " << j / 2 + 1 << "\n" << n - i << " " << j / 2 + 1 << "\n";
                } else {
                    cout << n - i << " " << m - j / 2 << "\n" << i + 1 << " " << m - j / 2 << "\n";
                }
                flag ^= 1;
            }
        }
    } else if (m % 2 == 0) {
        bool flag = false;
        for (int i = 0; i * 2 < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (!flag) {
                    cout << j / 2 + 1 << " " << m - i << "\n" << j / 2 + 1 << " " << i + 1 << "\n";
                } else {
                    cout << n - j / 2 << " " << i + 1 << "\n" << n - j / 2 << " " << m - i << "\n";
                }
                flag ^= 1;
            }
        }
    } else {
        vector<pii> v;
        assert(n >= 3 && m >= 3 && n % 2 == 1 && m % 2 == 1);
        bool flag = false;
        for (int i = 0; i * 2 < n - 3; ++i) {
            for (int j = 0; j < m; ++j) {
                if (!flag) {
                    //cout << i + 1 << " " << j / 2 + 1 << "\n" << n - i << " " << j / 2 + 1 << "\n";
                    v.puba({i, j / 2});
                    v.puba({n - i - 1, j / 2});
                } else {
                    //cout << n - i << " " << m - j / 2 << "\n" << i + 1 << " " << m - j / 2 << "\n";
                    v.puba({n - i - 1, m - j / 2 - 1});
                    v.puba({i, m - j / 2 - 1});
                }
                flag ^= 1;
            }
        }
        flag ^= 1;
        int x0 = (n - 3) / 2;
        int y0 = (m - 3) / 2;
        for (int i = 0; i * 2 < m - 3; ++i) {
            for (int j = 0; j < 3; ++j) {
                if (!flag) {
                    //cout << x0 + j / 2 + 1 << " " << m - i << "\n" << x0 + j / 2 + 1 << " " << i + 1 << "\n";
                    v.puba({x0 + j / 2, m - i - 1});
                    v.puba({x0 + j / 2, i});
                } else {
                    //cout << x0 + 3 - j / 2 << " " << i + 1 << "\n" << x0 + 3 - j / 2 << " " << m - i << "\n";
                    v.puba({x0 + 3 - j / 2 - 1, i});
                    v.puba({x0 + 3 - j / 2 - 1, m - i - 1});
                }
                flag ^= 1;
            }
        }
        vector<pii> points;
        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 3; ++j) {
                points.puba({x0 + i, y0 + j});
            }
        }
        vector<int> order;
        for (int i = 0; i < 9; ++i) {
            order.puba(i);
        }

        do {
            bool good = true;
            int tmpx = v.back().ff - v[szof(v) - 2].ff;
            int tmpy = v.back().ss - v[szof(v) - 2].ss;
            int dx = points[order[0]].ff - v.back().ff;
            int dy = points[order[0]].ss - v.back().ss;
            if (tmpx * dy - tmpy * dx <= 0) {
                continue;
            }
            for (int i = 1; i < 9; ++i) {
                int dx2 = points[order[i]].ff - points[order[i - 1]].ff;
                int dy2 = points[order[i]].ss - points[order[i - 1]].ss;
                if (dx * dy2 - dy * dx2 <= 0) {
                    good = false;
                    break;
                }
                dx = dx2;
                dy = dy2;
            }
            if (good) {
                for (int i : order) {
                    v.puba(points[i]);
                }
                break;
            }
        } while (next_permutation(bend(order)));
        for (pii p : v) {
            cout << p.ff + 1 << " " << p.ss + 1 << "\n";
        }
    }
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}