#include "testlib.h"
#include <cassert>

using namespace std;

int main(int argc, char **argv) {
  registerGen(argc, argv, 1);
  int n = atoi(argv[1]);
  int m = atoi(argv[2]);
  int A = atoi(argv[3]);
  int bound = atoi(argv[4]);
  vector<int> value(n);
  for (int i = 0; i < n; i++) {
    value[i] = i + 1;
    if (rnd.next(2) == 0) {
      value[i] *= -1;
    }
  }
  vector<int> appearances(n, 0);
  vector< vector<int> > a(m);
  for (int i = 0; i < m; i++) {
    vector<int> candidates;
    for (int j = 0; j < n; j++) {
      if (appearances[j] < bound) {
        candidates.push_back(j);
      }
    }
    assert(!candidates.empty());
    shuffle(candidates.begin(), candidates.end());
    for (int j = 0; j < min(A, (int) candidates.size()); j++) {
      a[i].push_back(value[candidates[j]]);
      appearances[candidates[j]]++;
    }
  }
  printf("%d %d\n", n, m);
  for (int i = m - 1; i >= 0; i--) {
    int sz = a[i].size();
    printf("%d", sz);
    for (int j = 0; j < sz; j++) {
      printf(" %d", a[i][j]);
    }
    printf("\n");
  }
  return 0;
}
