#include "testlib.h"

using namespace std;

int main(int argc, char **argv) {
  registerGen(argc, argv, 1);
  int n = atoi(argv[1]);
  int m = atoi(argv[2]);
  int A = atoi(argv[3]);
  double pos = atof(argv[4]);
  double neg = atof(argv[5]);
  vector< vector<int> > a(m);
  for (int i = 0; i < m; i++) {
    do {
      for (int j = 0; j < n; j++) {
        double z = rnd.next(1.0);
        if (z < pos) {
          a[i].push_back(j + 1);
        } else {
          if (z < pos + neg) {
            a[i].push_back(-j - 1);
          }
        }
      }
    } while (a[i].empty());
    while ((int) a[i].size() > A) {
      int pos = rnd.next(a[i].size());
      a[i].erase(a[i].begin() + pos);
    }
    shuffle(a[i].begin(), a[i].end());
  }
  printf("%d %d\n", n, m);
  for (int i = 0; i < m; i++) {
    int sz = a[i].size();
    printf("%d", sz);
    for (int j = 0; j < sz; j++) {
      printf(" %d", a[i][j]);
    }
    printf("\n");
  }
  return 0;
}
