#include "testlib.h"

using namespace std;

int const MAX = 200000;

int main(int argc, char* argv[]) {
  	registerValidation(argc, argv);
  	int tests = inf.readInt(1, MAX / 2, "T");
 	inf.readEoln();
 	int sumM = 0, sumN = 0;
 	for (int test = 1; test <= tests; test++) {
		int n = inf.readInt(2, MAX, "n");
		inf.readSpace();
		int m = inf.readInt(2, MAX, "m");
		inf.readEoln();
		for (int i = 0; i < m; i++) {
			int u = inf.readInt(1, n, "u");
			inf.readSpace();
			int v = inf.readInt(1, n, "v");
			inf.readSpace();
			int color = inf.readInt(1, m, "c");
			inf.readEoln();
			ensuref(u != v, "Loop %d -> %d encountered in test %d", u, v, test);
		}
		sumM += m;
		sumN += n;
		ensuref(sumM <= MAX, "Total number of edges = %d exceeds %d", sumM, MAX);
		ensuref(sumN <= MAX, "Total number of vertices = %d exceeds %d", sumN, MAX);	
	}
	inf.readEof();
}