#include "testlib.h"

const int MAXN = static_cast<int>(1e5);
const int MAXVALUE = static_cast<int>(1e9);

void ensureDirectionsString(const std::string &s, int n) {
  ensure(static_cast<int>(s.size()) == n);
  for (int i = 0; i < n; i++) {
    ensure(s[i] == 'L' || s[i] == 'R');
  }
}

int main(int argc, char* argv[])
{
  registerValidation(argc, argv);
  int n = inf.readInt(1, MAXN, "n");
  inf.readEoln();
  for (int i = 0; i < n; i++) {
    inf.readInt(1, MAXVALUE, "h[" + std::to_string(i) + "]");
    if (i + 1 < n) {
      inf.readSpace();
    } else {
      inf.readEoln();
    }
  }
  std::string s = inf.readLine();
  ensureDirectionsString(s, n);
  inf.readEof();
  return 0;
}
