#include <bits/stdc++.h>

const int maxn = static_cast<int>(1e5) + 10;

int n;
char s[maxn];
int h[maxn];
int result[maxn];

void process(char c, std::function<int(int)> getIndex) {
  std::vector<int> stack;
  for (int i = 0; i < n; i++) {
    if (s[i] == c) {
      result[getIndex(i)] = static_cast<int>(stack.size());
    }
    while (stack.size() > 0 && stack.back() < h[i]) {
      stack.pop_back();
    }
    stack.push_back(h[i]);
  }
}

int main() {
  scanf("%d", &n);
  for (int i = 0; i < n; i++) {
    scanf("%d", &h[i]);
  }
  scanf("%s", s);
  process('L', [](int i) {
    return i;
  });
  std::reverse(h, h + n);
  std::reverse(s, s + n);
  process('R', [](int i) {
    return n - i - 1;
  });
  for (int i = 0; i < n; i++) {
    printf("%d%c", result[i], " \n"[i + 1 == n]);
  }
}
