import java.io.*;
import java.util.Arrays;
import java.util.Random;
import java.util.StringTokenizer;

public class Drawing_gen_random {
    private FastScanner in;
    private PrintWriter out;

    private void solve() {
        if (!isMaxTest) {
            n = 1 + rnd.nextInt(n);
            m = 1 + rnd.nextInt(m);
        }
        out.println(n + " " + m);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int val = 4 + rnd.nextInt(8);
                out.print(val);
                if (j == m - 1) {
                    out.println();
                } else {
                    out.print(" ");
                }
            }
        }
    }

    private void run() {
        try {
            in = new FastScanner(new File("drawing.in"));
            out = new PrintWriter(new File("drawing.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    private void runIO() {
        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    private class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        boolean hasMoreTokens() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return false;
                st = new StringTokenizer(s);
            }
            return true;
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }
    }

    static boolean isMaxTest;
    static int n, m;
    static Random rnd;

    public static void main(String[] args) {
        n = Integer.parseInt(args[0]);
        m = Integer.parseInt(args[1]);
        isMaxTest = Integer.parseInt(args[2]) == 1;
        rnd = new Random(Integer.parseInt(args[3]));
        new Drawing_gen_random().runIO();
    }
}