#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int MAX_N = 1000;
const int MAX_M = 20;
const int MAX_A = 100;

int main(int argc, char* argv[]) {
  registerValidation(argc, argv);
  int n = inf.readInt(1, MAX_N, "n");
  inf.readSpace();
  int m = inf.readInt(1, MAX_M, "m");
  inf.readEoln();
  for (int i = 0; i < m; i++) {
    int a = inf.readInt(1, MAX_A, "a_" + to_string(i + 1));
    set<int> used;
    for (int j = 0; j < a; j++) {
      inf.readSpace();
      string b_s = "b_{" + to_string(i + 1) + "," + to_string(j + 1) + "}";
      int b = inf.readInt(-n, n, b_s);
      ensuref(b != 0, (b_s + " is equal to 0").c_str());
      if (b < 0) {
        b = -b;
      }
      ensuref(used.find(b) == used.end(), "variable %d occurs in clause %d twice", b, i + 1);
      used.insert(b);
    }
    inf.readEoln();
  }
  inf.readEof();
  return 0;
}
