/**
 *    author:  tourist
 *    created: 26.10.2017 08:41:47       
**/
#include <bits/stdc++.h>

using namespace std;

const int md = 998244353;

const int N = 2010;
const int M = 22;

vector<int> a[M], b[M];
int c[N];
int ans;
int n, m;
int p2[N];

void dfs(int v, int w, int cnt) {
  if (v == m) {
    if (w == 1) {
      ans = (ans + p2[n - cnt]) % md;
    } else {
      ans = (ans - p2[n - cnt] + md) % md;
    }
    return;
  }
  dfs(v + 1, w, cnt);
  bool ok = true;
  for (int j : a[v]) {
    if (c[j] < 0) {
      ok = false;
    }
    if (c[j] == 0) {
      cnt++;
    }
    c[j]++;
  }
  for (int j : b[v]) {
    if (c[j] > 0) {
      ok = false;
    }
    if (c[j] == 0) {
      cnt++;
    }
    c[j]--;
  }
  if (ok) {
    dfs(v + 1, -w, cnt);
  }
  for (int j : a[v]) {
    c[j]--;
  }
  for (int j : b[v]) {
    c[j]++;
  }
}

int main() {
  cin >> n >> m;
  for (int i = 0; i < m; i++) {
    int foo;
    cin >> foo;
    for (int j = 0; j < foo; j++) {
      int bar;
      cin >> bar;
      if (bar > 0) {
        a[i].push_back(bar - 1);
      } else {
        b[i].push_back(-bar - 1);
      }
    }
  }
  p2[0] = 1;
  for (int i = 0; i < n; i++) {
    p2[i + 1] = (p2[i] + p2[i]) % md;
  }
  ans = 0;
  dfs(0, 1, 0);
  printf("%d\n", ans);
  return 0;
}
