import java.io.*;
import java.util.*;

public class twinter_md {
	public static final int MAX_NEW = 280;

	public void run() {
		int n = in.nextInt();
		in.nextLine();
		ArrayList<String> text = new ArrayList<>();
		for (int i = 0; i < n; i++) {
			String s = in.nextLine();
			String[] tokens = s.split(" ");
			for (int j = 0; j < tokens.length - 1; j++) {
				text.add(tokens[j]);
			}
		}
		ArrayList<String> ans = null;
		int low = 0;
		int high = n + 1;
		while (low + 1 < high) {
			int m = (low + high) / 2;
			ArrayList<String> list = new ArrayList<String>();
			int k = 0;
			for (int i = 0; i < m; i++) {
				StringBuilder sb = new StringBuilder();
				int space = MAX_NEW - 3 - ("" + m).length() - ("" + (i + 1)).length();
				while (k < text.size() && text.get(k).length() + 1 <= space) {
					sb.append(text.get(k)).append(" ");
					space -= text.get(k).length() + 1;
					k++;
				}
				sb.append("(").append(i + 1).append("/").append(m).append(")");
				list.add(sb.toString());
			}
			if (k < text.size()) {
				low = m;
			} else {
				high = m;
				ans = list;
			}
		}
		out.println(ans.size());
		for (String s : ans) {
			out.println(s);
		}
	}

	static Scanner in;
	static PrintWriter out;

	public static void main(String[] args) throws IOException {
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
		new twinter_md().run();
		in.close();
		out.close();
	}
}
